Debian Bug report logs - #473296
resolver should satisfy deps using higher priority packages before lower priority packages

version graph

Package: aptitude; Maintainer for aptitude is Aptitude Development Team <aptitude-devel@lists.alioth.debian.org>; Source for aptitude is src:aptitude.

Reported by: CSights <csights@fastmail.fm>

Date: Sat, 29 Mar 2008 20:09:01 UTC

Severity: normal

Found in versions aptitude/0.4.11-3, aptitude/0.4.11.11-1~lenny1

Fixed in version aptitude/0.5.2-1

Done: Daniel Burrows <dburrows@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#473296; Package aptitude. Full text and rfc822 format available.

Acknowledgement sent to CSights <csights@fastmail.fm>:
New Bug report received and forwarded. Copy sent to Daniel Burrows <dburrows@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: CSights <csights@fastmail.fm>
To: submit@bugs.debian.org
Subject: resolver should satisfy deps using higher priority packages before lower priority packages
Date: Fri, 28 Mar 2008 19:08:14 -0400
Package: aptitude
Version: 0.4.11-3+b1
Severity: normal

Hi,
	I'm about to update a package (libc6-i686).  After selecting the newer 
version of the package (2.7-9) in the GUI the package is "broken" and the 
resolver attempts to satisfy broken dependencies.
	The first suggestion is to remove libc6-i686.  Fine, that would work.
	The second suggestion is to upgrade:
libc6		[2.7-6 testing, now -> 2.7-9ubuntu2 hardy]
libc6-dev	[2.7-6 testing, now -> 2.7-9ubuntu2 hardy]
libc6-i686	[2.7-6 testing, now -> 2.7-9ubuntu2 hardy]

	and the third suggestion is to upgrade
libc6		[2.7-6 testing, now -> 2.7-9 unstable]
libc6-dev	[2.7-6 testing, now -> 2.7-9 unstable]

	What I think should happen is that the 3rd suggestion should come before the 
2nd suggestion because Debian unstable has a higher priority (50) than Ubuntu 
hardy (25).
	Even stranger, when I pretend to want to install libc6-i686=2.7-9 from the 
command line instead of the GUI, the resolver makes the "better" 3rd 
suggestion first thing:

#aptitude install -s libc6-i686=2.7-9
The following packages are BROKEN:
  libc6-i686
1 packages upgraded, 0 newly installed, 0 to remove and 51 not upgraded.
Need to get 1261kB of archives. After unpacking 86.0kB will be used.
The following packages have unmet dependencies:
  libc6-i686: PreDepends: libc6 (= 2.7-9) but 2.7-6 is installed.
Resolving dependencies...
The following actions will resolve these dependencies:

Upgrade the following packages:
libc6 [2.7-6 (testing, now) -> 2.7-9 (unstable)]
libc6-dev [2.7-6 (testing, now) -> 2.7-9 (unstable)]

Score is -10




Thanks!
	C.


--- System information. ---
Architecture: i386
Kernel:       Linux 2.6.24.4

Debian Release: lenny/sid
  990 testing         security.debian.org 
  990 testing         ftp.egr.msu.edu 
  980 testing         ftp.sunet.se 
   50 unstable        ftp.uwsg.indiana.edu 
   40 experimental    ftp.egr.msu.edu 
   25 unstable        ftp.sunet.se 
   25 hardy           us.archive.ubuntu.com 

--- Package information. ---
Depends                                (Version) | Installed
================================================-+-====================
libapt-pkg-libc6.7-6-4.6                         | 
libc6                                 (>= 2.7-1) | 2.7-6
libcwidget3                                      | 0.5.9-1
libept0                                          | 0.5.14
libgcc1                          (>= 1:4.1.1-21) | 1:4.3.0-1
libncursesw5                 (>= 5.6+20071006-3) | 5.6+20080203-1
libsigc++-2.0-0c2a                    (>= 2.0.2) | 2.0.18-2
libstdc++6                          (>= 4.2.1-4) | 4.3.0-1
libxapian15                                      | 1.0.5-1
zlib1g                                           | 1:1.2.3.3.dfsg-11




Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#473296; Package aptitude. (Thu, 08 Jan 2009 22:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to C Sights <csights@fastmail.fm>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. (Thu, 08 Jan 2009 22:15:03 GMT) Full text and rfc822 format available.

Message #10 received at 473296@bugs.debian.org (full text, mbox):

From: C Sights <csights@fastmail.fm>
To: 473296@bugs.debian.org
Subject: [aptitude] another example of lower priority preferred over higher priority package
Date: Thu, 8 Jan 2009 17:13:45 -0500
Package: aptitude
Version: 0.4.11.11-1~lenny1

Hi all,
	Another example of a lower priority package being favored over a higher 
priority package when manually upgrading workrave from 1.8.5 to 1.9.0, using 
workrave.
	The interactive text interface suggests that an Ubuntu package should be 
installed:
libcairomm-1.0-1 [1.6.0-1 (testing, now) -> 1.6.4-1 (intrepid)]
	even though the package of libcairomm-1.0-1 in the Debian repository has 
higher priority:
-----------------
# apt-cache policy libcairomm-1.0-1
libcairomm-1.0-1:
  Installed: 1.6.0-1
  Candidate: 1.6.0-1
  Version table:
     1.6.4-1 0
         50 http://ftp.egr.msu.edu unstable/main Packages
     1.6.4-1 0
         30 http://us.archive.ubuntu.com intrepid/main Packages
 *** 1.6.0-1 0
        990 http://ftp.egr.msu.edu testing/main Packages
        100 /var/lib/dpkg/status
-----------------
	On the other hand he command-line resolver "does the right thing" by 
suggesting that the higher priority Debian package be installed:
(key line) libcairomm-1.0-1 [1.6.0-1 (testing, now) -> 1.6.4-1 (unstable)]
-----------------
# aptitude install -s workrave=1.9.0-6                                
Reading package lists... Done                                                 
Building dependency tree                                                      
Reading state information... Done                                             
Reading extended state information
Initializing package states... Done
The following packages are BROKEN:
  workrave
The following NEW packages will be installed:
  libgdome2-0{a}
The following packages will be REMOVED:
  workrave-data{u}
1 packages upgraded, 1 newly installed, 1 to remove and 0 not upgraded.
Need to get 411kB of archives. After unpacking 1188kB will be freed.
The following packages have unmet dependencies:
  workrave: Depends: libcairomm-1.0-1 (>= 1.6.4) but 1.6.0-1 is installed.
            Depends: workrave-data (= 1.9.0-6) but it is not installable
The following actions will resolve these dependencies:

Upgrade the following packages:
libcairomm-1.0-1 [1.6.0-1 (testing, now) -> 1.6.4-1 (unstable)]
workrave-data [1.8.5-7 (testing, now) -> 1.9.0-6 (unstable)]
-----------------
	As far as I've tested (very rarely) the command-line resolver seems to 
satisfy dependencies based on the priority of the packages.  A step in the 
right direction would to have the interactive text resolver use the same 
logic as the command-line resolver.  

Thanks!
	C.

--- System information. ---
Architecture: i386
Kernel:       Linux 2.6.28

Debian Release: 5.0
  990 testing         security.debian.org 
  990 testing         ftp.egr.msu.edu 
  980 testing         mirror.csclub.uwaterloo.ca 
   50 unstable        ftp.egr.msu.edu 
   40 experimental    http.us.debian.org 
   30 intrepid        us.archive.ubuntu.com 
   25 unstable        mirror.csclub.uwaterloo.ca 

--- Package information. ---
Depends                                (Version) | Installed
================================================-+-====================
libapt-pkg-libc6.7-6-4.6                         | 
libc6                                 (>= 2.7-1) | 2.7-16
libcwidget3                                      | 0.5.12-3
libept0                              (>= 0.5.22) | 0.5.25
libgcc1                             (>= 1:4.1.1) | 1:4.3.2-1
libncursesw5                 (>= 5.6+20071006-3) | 5.7+20081213-1
libsigc++-2.0-0c2a                    (>= 2.0.2) | 2.0.18-2
libstdc++6                            (>= 4.2.1) | 4.3.2-1
libxapian15                                      | 1.0.7-4
zlib1g                              (>= 1:1.1.4) | 1:1.2.3.3.dfsg-12




Tags added: pending Request was from Daniel Burrows <dburrows@debian.org> to control@bugs.debian.org. (Fri, 24 Apr 2009 02:06:09 GMT) Full text and rfc822 format available.

Reply sent to Daniel Burrows <dburrows@debian.org>:
You have taken responsibility. (Fri, 24 Apr 2009 15:22:06 GMT) Full text and rfc822 format available.

Notification sent to CSights <csights@fastmail.fm>:
Bug acknowledged by developer. (Fri, 24 Apr 2009 15:22:35 GMT) Full text and rfc822 format available.

Message #17 received at 473296-close@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: 473296-close@bugs.debian.org
Subject: Bug#473296: fixed in aptitude 0.5.2-1
Date: Fri, 24 Apr 2009 15:02:14 +0000
Source: aptitude
Source-Version: 0.5.2-1

We believe that the bug you reported is fixed in the latest version of
aptitude, which is due to be installed in the Debian FTP archive:

aptitude-dbg_0.5.2-1_i386.deb
  to pool/main/a/aptitude/aptitude-dbg_0.5.2-1_i386.deb
aptitude-doc-cs_0.5.2-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-cs_0.5.2-1_all.deb
aptitude-doc-en_0.5.2-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-en_0.5.2-1_all.deb
aptitude-doc-fi_0.5.2-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-fi_0.5.2-1_all.deb
aptitude-doc-fr_0.5.2-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-fr_0.5.2-1_all.deb
aptitude-doc-ja_0.5.2-1_all.deb
  to pool/main/a/aptitude/aptitude-doc-ja_0.5.2-1_all.deb
aptitude-gtk_0.5.2-1_i386.deb
  to pool/main/a/aptitude/aptitude-gtk_0.5.2-1_i386.deb
aptitude_0.5.2-1.diff.gz
  to pool/main/a/aptitude/aptitude_0.5.2-1.diff.gz
aptitude_0.5.2-1.dsc
  to pool/main/a/aptitude/aptitude_0.5.2-1.dsc
aptitude_0.5.2-1_i386.deb
  to pool/main/a/aptitude/aptitude_0.5.2-1_i386.deb
aptitude_0.5.2.orig.tar.gz
  to pool/main/a/aptitude/aptitude_0.5.2.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 473296@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Burrows <dburrows@debian.org> (supplier of updated aptitude package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 23 Apr 2009 09:08:27 -0700
Source: aptitude
Binary: aptitude aptitude-gtk aptitude-dbg aptitude-doc-cs aptitude-doc-en aptitude-doc-fi aptitude-doc-fr aptitude-doc-ja
Architecture: source i386 all
Version: 0.5.2-1
Distribution: experimental
Urgency: low
Maintainer: Daniel Burrows <dburrows@debian.org>
Changed-By: Daniel Burrows <dburrows@debian.org>
Description: 
 aptitude   - terminal-based package manager (terminal interface only)
 aptitude-dbg - Debug symbols for the aptitude package manager
 aptitude-doc-cs - Czech manual for aptitude, a terminal-based package manager
 aptitude-doc-en - English manual for aptitude, a terminal-based package manager
 aptitude-doc-fi - Finnish manual for aptitude, a terminal-based package manager
 aptitude-doc-fr - French manual for aptitude, a terminal-based package manager
 aptitude-doc-ja - Japanese manual for aptitude, a terminal-based package manager
 aptitude-gtk - terminal-based package manager (GUI and terminal interfaces)
Closes: 473296 482825 510977 511238 512384 513472 514011 514545 514676 514714 514820 514930 516296 516296 516389 516527 517272 518981 519693 521152 521255 522881 524221 524667
Changes: 
 aptitude (0.5.2-1) experimental; urgency=low
 .
   * New upstream release.
 .
     - Support for guaranteed ordering of solutions produced by the
     dependency resolver. (Closes: #514820, #514930, #524221, #473296)
 .
     - The dependency resolver will continue searching for a short time
       after finding a solution, in case a better solution turns up.
       (Closes: #482825)
 .
     - The GTK+ interface should no longer crash while trying to find
       dependency chains. (Closes: #514714)
 .
     - aptitude is now more careful about automatically canceling the
       removal of an unused package, to avoid triggering a conflict with
       other packages (for instance, packages included in a dependency
       solution). (Closes: #522881, #524667)
 .
     - The curses interface no longer warns users when they purge an
       already-removed Essental package. (Closes: #513472)
 .
     - The curses interface no longer computes an excessive amount of
       dependency information every time a package is highlighted.
       (Closes: #516296)
 .
     - Fixed incorrect formatting in some command-line error messages.
       (Closes: #516296, #514676)
 .
     - Fix really stupid column wrapping in "aptitude why".
       (Closes: #516389)
 .
     - Translation updates:
 .
       + Asturian (Closes: #518981, #519693)
       + Danish (Closes: #512384)
       + German
       + Italian
       + Norwegian Bokmål (Closes: #510977)
       + Spanish (Closes: #517272)
       + Swedish (Closes: #511238, #514011)
 .
   * Change the reportbug script to run in the C locale, so program output
     that's inserted doesn't get translated.
 .
   * Change the description of aptitude-gtk to say that it has a GUI
     interface. (Closes: #514545, #521152)
 .
   * Give aptitude-gtk a versioned dependency on aptitude. (Closes: #516527)
 .
   * Include .desktop file contributed by Fabit Greffrath.  I know that
     using su-to-root is not ideal, but since aptitude-gtk can't be used to
     install / remove packages unless it's run as root, this is probably a
     good interim approach.  Eventually we'll hook up the code so that the
     GTK+ frontend can do what the curses frontend does (automagically
     become root and preserve selections). (Closes: #521255)
 .
   * New build-deps: liblog4cxx10-dev, inkscape.
Checksums-Sha1: 
 14f15b10147b5b9572c6937fa6b5949d377b8a94 1470 aptitude_0.5.2-1.dsc
 b138312be6fcc90c81dc4c005717d512f57ea750 7133402 aptitude_0.5.2.orig.tar.gz
 ec7e4ac6bb16106322a92a6f4227bbba6c81ef96 35501 aptitude_0.5.2-1.diff.gz
 6113b0b646e805bd4f3682c345c44fe77025db5d 3330290 aptitude_0.5.2-1_i386.deb
 61d8aba41318a80441fda0fb6e43a443a01c558d 1487680 aptitude-gtk_0.5.2-1_i386.deb
 554f45fe2c4a28ca0496e07326a672dd1b9ca499 16278950 aptitude-dbg_0.5.2-1_i386.deb
 53b100d1d1ea89a350d30365ef7b1a00848bff8f 379860 aptitude-doc-cs_0.5.2-1_all.deb
 6b7d2da18ab7034cdc53fd752ae8d1be794bafb3 377440 aptitude-doc-en_0.5.2-1_all.deb
 b54e2c2bddef79b78295c653459ddf6266728003 271822 aptitude-doc-fi_0.5.2-1_all.deb
 8d5811fd20a918d3a2235e22cb461417e4c26f36 325090 aptitude-doc-fr_0.5.2-1_all.deb
 7a3a746145011cf43915be822b34b0bf83786579 388792 aptitude-doc-ja_0.5.2-1_all.deb
Checksums-Sha256: 
 3fd4c2436207d4e547ef1b834e56f3ed53d064a24086883a355946cb9669a9af 1470 aptitude_0.5.2-1.dsc
 491c7471219addaa7769655837c81206da80cc2f0ef7c510707d1499073715be 7133402 aptitude_0.5.2.orig.tar.gz
 3f8c3535a5903ae2596ec74b5253daaf20d026db4e8e2b78c8bddf832d4a9bc9 35501 aptitude_0.5.2-1.diff.gz
 73d04bfe1a88352a15ed41002d2aea6fd07291e5698c5b885c53648f4597d40e 3330290 aptitude_0.5.2-1_i386.deb
 6207d9746703f729a61d5c8b5a1f58b28c79f656f9fa0520c73a4d41e4b6a15a 1487680 aptitude-gtk_0.5.2-1_i386.deb
 6e0fbc933f99f7360b9d898e03df259bef433510724f67bea28241f4b23eac4d 16278950 aptitude-dbg_0.5.2-1_i386.deb
 acb2168e036b4966eb0bf4957cf5a12281e58350cbaa782efcb0821641bdbc24 379860 aptitude-doc-cs_0.5.2-1_all.deb
 d88bf0bc1c1aa78f1559d1d0752926a3ac5dae8b8eb0e0d1a5744c9b5f965356 377440 aptitude-doc-en_0.5.2-1_all.deb
 cf5a2c2335d7aa390fa024b0746431cafc873b3e1e38f4f8891b82b94056efcc 271822 aptitude-doc-fi_0.5.2-1_all.deb
 efacac86bb4ddf5d883d28449f30cf9f9992ed8f3f4a38e178d3a92753ef40eb 325090 aptitude-doc-fr_0.5.2-1_all.deb
 93b03cd14daa3b1f439e075e56a82ff7dd9d4eec798ba0c9d6abe8b4b55361c2 388792 aptitude-doc-ja_0.5.2-1_all.deb
Files: 
 bcfeb8ecb6ed184a74bd5eaa47b09bf7 1470 admin - aptitude_0.5.2-1.dsc
 074aeb68c570003a58f42d1e6031fa25 7133402 admin - aptitude_0.5.2.orig.tar.gz
 1e5c119f64d2ba7af4ea9c2fa71bf0d3 35501 admin - aptitude_0.5.2-1.diff.gz
 84265fa156faaaeb731a57acab855f9c 3330290 admin important aptitude_0.5.2-1_i386.deb
 f2ecb4df9b8d592c9b690c99ca37c86e 1487680 admin important aptitude-gtk_0.5.2-1_i386.deb
 ec67d6e719d9d3dc79495c62578764be 16278950 devel extra aptitude-dbg_0.5.2-1_i386.deb
 13c8fd668a55fe601d727def826f1167 379860 doc optional aptitude-doc-cs_0.5.2-1_all.deb
 620760f6d415a6c4f6994281e0c98089 377440 doc optional aptitude-doc-en_0.5.2-1_all.deb
 63de5659873f329ec0eb9183fd7c9c11 271822 doc optional aptitude-doc-fi_0.5.2-1_all.deb
 e44fe09a6758a787f5f50074b8056391 325090 doc optional aptitude-doc-fr_0.5.2-1_all.deb
 19d76cd2ebe35d7b5a7490cd9d820c16 388792 doc optional aptitude-doc-ja_0.5.2-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAknxxhMACgkQch6xsM7kSXiFZACgw5tIvOzMjJ+ooOw4sFQttOfI
BAsAoNjJ2rMrw78+q65/SaTeXZvl4xEX
=NIZF
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 23 Mar 2010 07:47:16 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 25 02:09:30 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.